﻿using Syncfusion.UI.Xaml.Grid;
using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SyncfusionBugReplication
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private readonly ViewModel _model = new ViewModel(50);

        public MainPage()
        {
            InitializeComponent();
            DataContext = _model;

            grid.CellRenderers.Remove("Template");
            grid.CellRenderers.Add("Template", new CustomGridCellTemplateRenderer());

            var col = new GridTextColumn
                {
                    MappingName = "Number",
                    ValueBinding = new Binding {Path = new PropertyPath("Number")},
                    UseBindingValue = true,
                    AllowFiltering = true,
                    ColumnSizer = GridLengthUnitType.SizeToHeader
                };

            grid.Columns.Add(col);

            for (var i = 0; i < 5; i++)
            {
                var mappingName = string.Format("Randoms[{0}]", i);

                col = new GridTextColumn
                    {
                        MappingName = mappingName,
                        ValueBinding = new Binding {Path = new PropertyPath(mappingName)},
                        UseBindingValue = true,
                        AllowFiltering = true,
                        ColumnSizer = GridLengthUnitType.SizeToHeader
                    };

                grid.Columns.Add(col);
            }
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            grid.Columns.Clear();

            var col = new GridTemplateColumn
                {
                    CellTemplate = (DataTemplate) Resources["SampleTemplate"],
                    MappingName = "Number",
                    ValueBinding = new Binding {Path = new PropertyPath("Number")},
                    UseBindingValue = true,
                    AllowFiltering = true,
                    ColumnSizer = GridLengthUnitType.SizeToHeader
                };

            grid.Columns.Add(col);

            for (var i = 0; i < 5; i++)
            {
                var mappingName = string.Format("Randoms[{0}]", i);

                col = new GridTemplateColumn
                    {
                        CellTemplate = (DataTemplate) Resources["SampleTemplate"],
                        MappingName = mappingName,
                        ValueBinding = new Binding {Path = new PropertyPath(mappingName)},
                        UseBindingValue = true,
                        AllowFiltering = true,
                        ColumnSizer = GridLengthUnitType.SizeToHeader
                    };

                grid.Columns.Add(col);
            }
        }
    }

    public class IntegerToBooleanConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var num = (int)value;

            return num > 5000;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
